# Countdown

## Description

Countdown is a 1982 British game show involving word and number tasks. There are
two contestants in each episode that compete in three game types: letters
rounds, in which the contestants attempt to make the longest word possible from
nine randomly chosen letters; numbers rounds, in which the contestants must
use arithmetic to reach a random target number from six other numbers; and the
conundrum, a buzzer round in which the contestants compete to solve a
nine-letter anagram.

### Letters Round
The contestant in control chooses between two stacks of letter tiles, one
containing vowels (A-E-I-O-U only) and the other consonants, and the assistant
reveals the top tile from that stack and places it on the board. This is done
nine times, and the final grouping must contain at least three vowels and four
consonants. The contestants then have 30 seconds to form the longest single
word they can, using the nine revealed letters; no letter may be used more often
than it appears in the selection.

#### Example
Contestant One chooses five consonants, then three vowels, then another
consonant.

Selection is: `G Y H D N O E U R`

Contestant One declares 7, while Contestant Two declares 8.

Contestant One reveals `younger`, but Contestant Two reveals `hydrogen` and
scores 8 points. Contestant One does not score.

### Numbers Round
The contestant in control chooses six of 24 shuffled face-down number tiles,
arranged into two groups: 20 "small numbers" (two each of 1 to 10), and four
"large numbers" of 25, 50, 75, and 100. Some special episodes replace the large
numbers with 12, 37, 62, and 87. The contestant decides how many large numbers
are to be used, from none to all four, after which the six tiles are randomly
drawn and placed on the board. Then, a random three-digit target number is then
generated by an electronic machine. The contestants have 30 seconds to work out
a sequence of calculations with the numbers whose final result is as close to
the target number as possible. They may use only the four basic operations of
addition, subtraction, multiplication and division, and do not have to use all
six numbers. A number may not be used more times than it appears on the board.
Division can only be performed if the result has no remainder. Fractions are not
allowed, and only positive integers may be obtained as a result at any stage of
the calculation.

#### Example
Contestant One requests two large numbers and four small numbers.

Selection is: 75 50 2 3 8 7

Randomly generated target is: 812

Contestant One declares 813, while Contestant Two declares 815.

Contestant One is closer and so reveals: 75 + 50 – 8 = 117, and 117 × 7 – (3 ×
2) = 813, which scores 7 points for being 1 away. Contestant Two does not score.

# Solvers
- `numbers-round.py` is a solver for the Numbers Round.
