## FileMagic Organizer - Unleash the Power of Order

Welcome to FileMagic Organizer, where chaos meets its match. This Python script is your ally in the battle against cluttered directories. FileMagic Organizer effortlessly sorts your files into designated categories, bringing harmony to the digital realm.

## Index
- [Introduction](#)
- [Key Features](#key-features)
- [Getting Started](#getting-started)
- [Options provided](#options-provided)
- [Usage](#usage)
- [Customization](#customization)

## Key Features:

- 🔮 **Magical Categorization:** FileMagic Organizer intelligently sorts files by type, creating a structured and easily navigable file system.

- 📅 **Chronological Arrangement:** Dive into the past with chronological organization, unveiling the history of your files in an orderly timeline.

📏 **Size-based Sorting:** Experience the wizardry of size-based categorization, with files neatly grouped into small, medium, and large categories.

## **Getting Started:**

1. ⚡ **Clone the Repository:** Embrace the magic by cloning the FileMagic Organizer repository.

2. 🚀 **Install Dependencies:** Initiate the enchantment with a quick installation of the required Python libraries.

3. ✨ **Run the Magic Spell:** Execute the script, follow the prompts, and witness the transformation as FileMagic Organizer weaves its organizational magic.

## Options provided

- Organize files by type (e.g., images, documents, videos).
- Organize files by creation date into a hierarchical structure of year and month.
- Categorize files by size into small, medium, and large categories.

## Usage

1. **Clone the Repository:**

   ```bash
   git clone https://github.com/malivinayak/file-organizer.git
   cd file-organizer
   ```

2. **Install Dependencies:**

   Ensure you have Python installed. Install the required libraries:

   ```bash
   pip install -r requirements.txt
   ```

3. **Run the Script:**

   ```bash
   python organize_files.py
   ```

## Customization

- Adjust the file type categories, file extensions, and any other settings in the script based on your needs.
- Modify the size categories and ranges in the script for organizing files by size.
